/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 3 "rcfile_y.y"

/*
 * rcfile_y.y -- Run control file parser for fetchmail
 *
 * For license terms, see the file COPYING in this directory.
 */

#include "config.h"
#include "fetchmail.h"
#include <stdio.h>
#include <sys/types.h>
#include <sys/file.h>
#include <sys/wait.h>
#include <sys/stat.h>
#include <errno.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

#include "i18n.h"
#include "rcfile_l.h"
  
/* parser reads these */
char *rcfile;			/* path name of rc file */
struct query cmd_opts;		/* where to put command-line info */

/* parser sets these */
struct query *querylist;	/* head of server list (globally visible) */

static struct query current;	/* current server record */
static int prc_errflag;
static struct hostdata *leadentry;
static flag trailer;

static void record_current(void);
static void user_reset(void);
static void reset_server(const char *name, int skip);

/* these should be of size PATH_MAX */
char currentwd[1024] = "", rcfiledir[1024] = "";

/* lexer interface */
extern int prc_lineno;
void yyerror (const char *s)
/* report a syntax or out-of-memory error */
{
    report_at_line(stderr, 0, rcfile, prc_lineno, GT_("%s at %s"), s, 
		   (yytext && yytext[0]) ? yytext : GT_("end of input"));
    prc_errflag++;
}


#line 124 "rcfile_y.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

/* Use api.header.include to #include this header
   instead of duplicating it here.  */
#ifndef YY_YY_RCFILE_Y_H_INCLUDED
# define YY_YY_RCFILE_Y_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token kinds.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    YYEMPTY = -2,
    YYEOF = 0,                     /* "end of file"  */
    YYerror = 256,                 /* error  */
    YYUNDEF = 257,                 /* "invalid token"  */
    DEFAULTS = 258,                /* DEFAULTS  */
    POLL = 259,                    /* POLL  */
    SKIP = 260,                    /* SKIP  */
    VIA = 261,                     /* VIA  */
    AKA = 262,                     /* AKA  */
    LOCALDOMAINS = 263,            /* LOCALDOMAINS  */
    PROTOCOL = 264,                /* PROTOCOL  */
    AUTHENTICATE = 265,            /* AUTHENTICATE  */
    TIMEOUT = 266,                 /* TIMEOUT  */
    IDLETIMEOUT = 267,             /* IDLETIMEOUT  */
    KPOP = 268,                    /* KPOP  */
    SDPS = 269,                    /* SDPS  */
    ENVELOPE = 270,                /* ENVELOPE  */
    QVIRTUAL = 271,                /* QVIRTUAL  */
    USERNAME = 272,                /* USERNAME  */
    PASSWORD = 273,                /* PASSWORD  */
    FOLDER = 274,                  /* FOLDER  */
    SMTPHOST = 275,                /* SMTPHOST  */
    FETCHDOMAINS = 276,            /* FETCHDOMAINS  */
    MDA = 277,                     /* MDA  */
    BSMTP = 278,                   /* BSMTP  */
    LMTP = 279,                    /* LMTP  */
    PASSWORDFILE = 280,            /* PASSWORDFILE  */
    PASSWORDFD = 281,              /* PASSWORDFD  */
    SMTPADDRESS = 282,             /* SMTPADDRESS  */
    SMTPNAME = 283,                /* SMTPNAME  */
    SPAMRESPONSE = 284,            /* SPAMRESPONSE  */
    PRECONNECT = 285,              /* PRECONNECT  */
    POSTCONNECT = 286,             /* POSTCONNECT  */
    LIMIT = 287,                   /* LIMIT  */
    WARNINGS = 288,                /* WARNINGS  */
    INTERFACE = 289,               /* INTERFACE  */
    MONITOR = 290,                 /* MONITOR  */
    PLUGIN = 291,                  /* PLUGIN  */
    PLUGOUT = 292,                 /* PLUGOUT  */
    IS = 293,                      /* IS  */
    HERE = 294,                    /* HERE  */
    THERE = 295,                   /* THERE  */
    TO = 296,                      /* TO  */
    MAP = 297,                     /* MAP  */
    BATCHLIMIT = 298,              /* BATCHLIMIT  */
    FETCHLIMIT = 299,              /* FETCHLIMIT  */
    FETCHSIZELIMIT = 300,          /* FETCHSIZELIMIT  */
    FASTUIDL = 301,                /* FASTUIDL  */
    EXPUNGE = 302,                 /* EXPUNGE  */
    PROPERTIES = 303,              /* PROPERTIES  */
    SET = 304,                     /* SET  */
    LOGFILE = 305,                 /* LOGFILE  */
    DAEMON = 306,                  /* DAEMON  */
    SYSLOG = 307,                  /* SYSLOG  */
    IDFILE = 308,                  /* IDFILE  */
    PIDFILE = 309,                 /* PIDFILE  */
    INVISIBLE = 310,               /* INVISIBLE  */
    POSTMASTER = 311,              /* POSTMASTER  */
    BOUNCEMAIL = 312,              /* BOUNCEMAIL  */
    SPAMBOUNCE = 313,              /* SPAMBOUNCE  */
    SOFTBOUNCE = 314,              /* SOFTBOUNCE  */
    SHOWDOTS = 315,                /* SHOWDOTS  */
    BADHEADER = 316,               /* BADHEADER  */
    ACCEPT = 317,                  /* ACCEPT  */
    REJECT_ = 318,                 /* REJECT_  */
    PROTO = 319,                   /* PROTO  */
    AUTHTYPE = 320,                /* AUTHTYPE  */
    STRING = 321,                  /* STRING  */
    NUMBER = 322,                  /* NUMBER  */
    NO = 323,                      /* NO  */
    KEEP = 324,                    /* KEEP  */
    MOVETO = 325,                  /* MOVETO  */
    FLUSH = 326,                   /* FLUSH  */
    LIMITFLUSH = 327,              /* LIMITFLUSH  */
    FETCHALL = 328,                /* FETCHALL  */
    REWRITE = 329,                 /* REWRITE  */
    FORCECR = 330,                 /* FORCECR  */
    STRIPCR = 331,                 /* STRIPCR  */
    PASS8BITS = 332,               /* PASS8BITS  */
    DROPSTATUS = 333,              /* DROPSTATUS  */
    DROPDELIVERED = 334,           /* DROPDELIVERED  */
    FORCEIDLE = 335,               /* FORCEIDLE  */
    DNS = 336,                     /* DNS  */
    SERVICE = 337,                 /* SERVICE  */
    PORT = 338,                    /* PORT  */
    UIDL = 339,                    /* UIDL  */
    INTERVAL = 340,                /* INTERVAL  */
    MIMEDECODE = 341,              /* MIMEDECODE  */
    IDLE = 342,                    /* IDLE  */
    CHECKALIAS = 343,              /* CHECKALIAS  */
    SSL = 344,                     /* SSL  */
    SSLKEY = 345,                  /* SSLKEY  */
    SSLCERT = 346,                 /* SSLCERT  */
    SSLPROTO = 347,                /* SSLPROTO  */
    SSLCERTCK = 348,               /* SSLCERTCK  */
    SSLCERTFILE = 349,             /* SSLCERTFILE  */
    SSLCERTPATH = 350,             /* SSLCERTPATH  */
    SSLCOMMONNAME = 351,           /* SSLCOMMONNAME  */
    SSLFINGERPRINT = 352,          /* SSLFINGERPRINT  */
    PRINCIPAL = 353,               /* PRINCIPAL  */
    ESMTPNAME = 354,               /* ESMTPNAME  */
    ESMTPPASSWORD = 355,           /* ESMTPPASSWORD  */
    TRACEPOLLS = 356               /* TRACEPOLLS  */
  };
  typedef enum yytokentype yytoken_kind_t;
#endif
/* Token kinds.  */
#define YYEMPTY -2
#define YYEOF 0
#define YYerror 256
#define YYUNDEF 257
#define DEFAULTS 258
#define POLL 259
#define SKIP 260
#define VIA 261
#define AKA 262
#define LOCALDOMAINS 263
#define PROTOCOL 264
#define AUTHENTICATE 265
#define TIMEOUT 266
#define IDLETIMEOUT 267
#define KPOP 268
#define SDPS 269
#define ENVELOPE 270
#define QVIRTUAL 271
#define USERNAME 272
#define PASSWORD 273
#define FOLDER 274
#define SMTPHOST 275
#define FETCHDOMAINS 276
#define MDA 277
#define BSMTP 278
#define LMTP 279
#define PASSWORDFILE 280
#define PASSWORDFD 281
#define SMTPADDRESS 282
#define SMTPNAME 283
#define SPAMRESPONSE 284
#define PRECONNECT 285
#define POSTCONNECT 286
#define LIMIT 287
#define WARNINGS 288
#define INTERFACE 289
#define MONITOR 290
#define PLUGIN 291
#define PLUGOUT 292
#define IS 293
#define HERE 294
#define THERE 295
#define TO 296
#define MAP 297
#define BATCHLIMIT 298
#define FETCHLIMIT 299
#define FETCHSIZELIMIT 300
#define FASTUIDL 301
#define EXPUNGE 302
#define PROPERTIES 303
#define SET 304
#define LOGFILE 305
#define DAEMON 306
#define SYSLOG 307
#define IDFILE 308
#define PIDFILE 309
#define INVISIBLE 310
#define POSTMASTER 311
#define BOUNCEMAIL 312
#define SPAMBOUNCE 313
#define SOFTBOUNCE 314
#define SHOWDOTS 315
#define BADHEADER 316
#define ACCEPT 317
#define REJECT_ 318
#define PROTO 319
#define AUTHTYPE 320
#define STRING 321
#define NUMBER 322
#define NO 323
#define KEEP 324
#define MOVETO 325
#define FLUSH 326
#define LIMITFLUSH 327
#define FETCHALL 328
#define REWRITE 329
#define FORCECR 330
#define STRIPCR 331
#define PASS8BITS 332
#define DROPSTATUS 333
#define DROPDELIVERED 334
#define FORCEIDLE 335
#define DNS 336
#define SERVICE 337
#define PORT 338
#define UIDL 339
#define INTERVAL 340
#define MIMEDECODE 341
#define IDLE 342
#define CHECKALIAS 343
#define SSL 344
#define SSLKEY 345
#define SSLCERT 346
#define SSLPROTO 347
#define SSLCERTCK 348
#define SSLCERTFILE 349
#define SSLCERTPATH 350
#define SSLCOMMONNAME 351
#define SSLFINGERPRINT 352
#define PRINCIPAL 353
#define ESMTPNAME 354
#define ESMTPPASSWORD 355
#define TRACEPOLLS 356

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
union YYSTYPE
{
#line 56 "rcfile_y.y"

  int proto;
  int number;
  char *sval;

#line 385 "rcfile_y.c"

};
typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;


int yyparse (void);


#endif /* !YY_YY_RCFILE_Y_H_INCLUDED  */
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_DEFAULTS = 3,                   /* DEFAULTS  */
  YYSYMBOL_POLL = 4,                       /* POLL  */
  YYSYMBOL_SKIP = 5,                       /* SKIP  */
  YYSYMBOL_VIA = 6,                        /* VIA  */
  YYSYMBOL_AKA = 7,                        /* AKA  */
  YYSYMBOL_LOCALDOMAINS = 8,               /* LOCALDOMAINS  */
  YYSYMBOL_PROTOCOL = 9,                   /* PROTOCOL  */
  YYSYMBOL_AUTHENTICATE = 10,              /* AUTHENTICATE  */
  YYSYMBOL_TIMEOUT = 11,                   /* TIMEOUT  */
  YYSYMBOL_IDLETIMEOUT = 12,               /* IDLETIMEOUT  */
  YYSYMBOL_KPOP = 13,                      /* KPOP  */
  YYSYMBOL_SDPS = 14,                      /* SDPS  */
  YYSYMBOL_ENVELOPE = 15,                  /* ENVELOPE  */
  YYSYMBOL_QVIRTUAL = 16,                  /* QVIRTUAL  */
  YYSYMBOL_USERNAME = 17,                  /* USERNAME  */
  YYSYMBOL_PASSWORD = 18,                  /* PASSWORD  */
  YYSYMBOL_FOLDER = 19,                    /* FOLDER  */
  YYSYMBOL_SMTPHOST = 20,                  /* SMTPHOST  */
  YYSYMBOL_FETCHDOMAINS = 21,              /* FETCHDOMAINS  */
  YYSYMBOL_MDA = 22,                       /* MDA  */
  YYSYMBOL_BSMTP = 23,                     /* BSMTP  */
  YYSYMBOL_LMTP = 24,                      /* LMTP  */
  YYSYMBOL_PASSWORDFILE = 25,              /* PASSWORDFILE  */
  YYSYMBOL_PASSWORDFD = 26,                /* PASSWORDFD  */
  YYSYMBOL_SMTPADDRESS = 27,               /* SMTPADDRESS  */
  YYSYMBOL_SMTPNAME = 28,                  /* SMTPNAME  */
  YYSYMBOL_SPAMRESPONSE = 29,              /* SPAMRESPONSE  */
  YYSYMBOL_PRECONNECT = 30,                /* PRECONNECT  */
  YYSYMBOL_POSTCONNECT = 31,               /* POSTCONNECT  */
  YYSYMBOL_LIMIT = 32,                     /* LIMIT  */
  YYSYMBOL_WARNINGS = 33,                  /* WARNINGS  */
  YYSYMBOL_INTERFACE = 34,                 /* INTERFACE  */
  YYSYMBOL_MONITOR = 35,                   /* MONITOR  */
  YYSYMBOL_PLUGIN = 36,                    /* PLUGIN  */
  YYSYMBOL_PLUGOUT = 37,                   /* PLUGOUT  */
  YYSYMBOL_IS = 38,                        /* IS  */
  YYSYMBOL_HERE = 39,                      /* HERE  */
  YYSYMBOL_THERE = 40,                     /* THERE  */
  YYSYMBOL_TO = 41,                        /* TO  */
  YYSYMBOL_MAP = 42,                       /* MAP  */
  YYSYMBOL_BATCHLIMIT = 43,                /* BATCHLIMIT  */
  YYSYMBOL_FETCHLIMIT = 44,                /* FETCHLIMIT  */
  YYSYMBOL_FETCHSIZELIMIT = 45,            /* FETCHSIZELIMIT  */
  YYSYMBOL_FASTUIDL = 46,                  /* FASTUIDL  */
  YYSYMBOL_EXPUNGE = 47,                   /* EXPUNGE  */
  YYSYMBOL_PROPERTIES = 48,                /* PROPERTIES  */
  YYSYMBOL_SET = 49,                       /* SET  */
  YYSYMBOL_LOGFILE = 50,                   /* LOGFILE  */
  YYSYMBOL_DAEMON = 51,                    /* DAEMON  */
  YYSYMBOL_SYSLOG = 52,                    /* SYSLOG  */
  YYSYMBOL_IDFILE = 53,                    /* IDFILE  */
  YYSYMBOL_PIDFILE = 54,                   /* PIDFILE  */
  YYSYMBOL_INVISIBLE = 55,                 /* INVISIBLE  */
  YYSYMBOL_POSTMASTER = 56,                /* POSTMASTER  */
  YYSYMBOL_BOUNCEMAIL = 57,                /* BOUNCEMAIL  */
  YYSYMBOL_SPAMBOUNCE = 58,                /* SPAMBOUNCE  */
  YYSYMBOL_SOFTBOUNCE = 59,                /* SOFTBOUNCE  */
  YYSYMBOL_SHOWDOTS = 60,                  /* SHOWDOTS  */
  YYSYMBOL_BADHEADER = 61,                 /* BADHEADER  */
  YYSYMBOL_ACCEPT = 62,                    /* ACCEPT  */
  YYSYMBOL_REJECT_ = 63,                   /* REJECT_  */
  YYSYMBOL_PROTO = 64,                     /* PROTO  */
  YYSYMBOL_AUTHTYPE = 65,                  /* AUTHTYPE  */
  YYSYMBOL_STRING = 66,                    /* STRING  */
  YYSYMBOL_NUMBER = 67,                    /* NUMBER  */
  YYSYMBOL_NO = 68,                        /* NO  */
  YYSYMBOL_KEEP = 69,                      /* KEEP  */
  YYSYMBOL_MOVETO = 70,                    /* MOVETO  */
  YYSYMBOL_FLUSH = 71,                     /* FLUSH  */
  YYSYMBOL_LIMITFLUSH = 72,                /* LIMITFLUSH  */
  YYSYMBOL_FETCHALL = 73,                  /* FETCHALL  */
  YYSYMBOL_REWRITE = 74,                   /* REWRITE  */
  YYSYMBOL_FORCECR = 75,                   /* FORCECR  */
  YYSYMBOL_STRIPCR = 76,                   /* STRIPCR  */
  YYSYMBOL_PASS8BITS = 77,                 /* PASS8BITS  */
  YYSYMBOL_DROPSTATUS = 78,                /* DROPSTATUS  */
  YYSYMBOL_DROPDELIVERED = 79,             /* DROPDELIVERED  */
  YYSYMBOL_FORCEIDLE = 80,                 /* FORCEIDLE  */
  YYSYMBOL_DNS = 81,                       /* DNS  */
  YYSYMBOL_SERVICE = 82,                   /* SERVICE  */
  YYSYMBOL_PORT = 83,                      /* PORT  */
  YYSYMBOL_UIDL = 84,                      /* UIDL  */
  YYSYMBOL_INTERVAL = 85,                  /* INTERVAL  */
  YYSYMBOL_MIMEDECODE = 86,                /* MIMEDECODE  */
  YYSYMBOL_IDLE = 87,                      /* IDLE  */
  YYSYMBOL_CHECKALIAS = 88,                /* CHECKALIAS  */
  YYSYMBOL_SSL = 89,                       /* SSL  */
  YYSYMBOL_SSLKEY = 90,                    /* SSLKEY  */
  YYSYMBOL_SSLCERT = 91,                   /* SSLCERT  */
  YYSYMBOL_SSLPROTO = 92,                  /* SSLPROTO  */
  YYSYMBOL_SSLCERTCK = 93,                 /* SSLCERTCK  */
  YYSYMBOL_SSLCERTFILE = 94,               /* SSLCERTFILE  */
  YYSYMBOL_SSLCERTPATH = 95,               /* SSLCERTPATH  */
  YYSYMBOL_SSLCOMMONNAME = 96,             /* SSLCOMMONNAME  */
  YYSYMBOL_SSLFINGERPRINT = 97,            /* SSLFINGERPRINT  */
  YYSYMBOL_PRINCIPAL = 98,                 /* PRINCIPAL  */
  YYSYMBOL_ESMTPNAME = 99,                 /* ESMTPNAME  */
  YYSYMBOL_ESMTPPASSWORD = 100,            /* ESMTPPASSWORD  */
  YYSYMBOL_TRACEPOLLS = 101,               /* TRACEPOLLS  */
  YYSYMBOL_YYACCEPT = 102,                 /* $accept  */
  YYSYMBOL_statement_list = 103,           /* statement_list  */
  YYSYMBOL_optmap = 104,                   /* optmap  */
  YYSYMBOL_statement = 105,                /* statement  */
  YYSYMBOL_define_server = 106,            /* define_server  */
  YYSYMBOL_serverspecs = 107,              /* serverspecs  */
  YYSYMBOL_alias_list = 108,               /* alias_list  */
  YYSYMBOL_domain_list = 109,              /* domain_list  */
  YYSYMBOL_serv_option = 110,              /* serv_option  */
  YYSYMBOL_userspecs = 111,                /* userspecs  */
  YYSYMBOL_explicits = 112,                /* explicits  */
  YYSYMBOL_explicitdef = 113,              /* explicitdef  */
  YYSYMBOL_userdef = 114,                  /* userdef  */
  YYSYMBOL_user0opts = 115,                /* user0opts  */
  YYSYMBOL_user1opts = 116,                /* user1opts  */
  YYSYMBOL_mapping_list = 117,             /* mapping_list  */
  YYSYMBOL_mapping = 118,                  /* mapping  */
  YYSYMBOL_folder_list = 119,              /* folder_list  */
  YYSYMBOL_smtp_list = 120,                /* smtp_list  */
  YYSYMBOL_fetch_list = 121,               /* fetch_list  */
  YYSYMBOL_num_list = 122,                 /* num_list  */
  YYSYMBOL_user_option = 123               /* user_option  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_uint8 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if 1

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
# define YYCOPY_NEEDED 1
#endif /* 1 */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   351

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  102
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  22
/* YYNRULES -- Number of rules.  */
#define YYNRULES  159
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  234

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   356


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,    98,    98,    99,   100,   103,   103,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   123,   131,   132,   135,   139,   140,
     141,   144,   145,   148,   149,   152,   153,   156,   157,   158,
     159,   160,   171,   172,   173,   174,   182,   183,   184,   185,
     186,   189,   195,   201,   203,   205,   207,   209,   214,   220,
     221,   229,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   248,   249,   252,   253,   256,   259,   260,   261,   264,
     265,   268,   269,   272,   273,   276,   282,   285,   286,   289,
     290,   293,   294,   297,   303,   311,   312,   313,   314,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   347,   354,
     355,   356,   357,   358,   359,   360,   361,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     377,   378,   380,   381,   382,   383,   384,   385,   386,   388
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if 1
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  static const char *const yy_sname[] =
  {
  "end of file", "error", "invalid token", "DEFAULTS", "POLL", "SKIP",
  "VIA", "AKA", "LOCALDOMAINS", "PROTOCOL", "AUTHENTICATE", "TIMEOUT",
  "IDLETIMEOUT", "KPOP", "SDPS", "ENVELOPE", "QVIRTUAL", "USERNAME",
  "PASSWORD", "FOLDER", "SMTPHOST", "FETCHDOMAINS", "MDA", "BSMTP", "LMTP",
  "PASSWORDFILE", "PASSWORDFD", "SMTPADDRESS", "SMTPNAME", "SPAMRESPONSE",
  "PRECONNECT", "POSTCONNECT", "LIMIT", "WARNINGS", "INTERFACE", "MONITOR",
  "PLUGIN", "PLUGOUT", "IS", "HERE", "THERE", "TO", "MAP", "BATCHLIMIT",
  "FETCHLIMIT", "FETCHSIZELIMIT", "FASTUIDL", "EXPUNGE", "PROPERTIES",
  "SET", "LOGFILE", "DAEMON", "SYSLOG", "IDFILE", "PIDFILE", "INVISIBLE",
  "POSTMASTER", "BOUNCEMAIL", "SPAMBOUNCE", "SOFTBOUNCE", "SHOWDOTS",
  "BADHEADER", "ACCEPT", "REJECT_", "PROTO", "AUTHTYPE", "STRING",
  "NUMBER", "NO", "KEEP", "MOVETO", "FLUSH", "LIMITFLUSH", "FETCHALL",
  "REWRITE", "FORCECR", "STRIPCR", "PASS8BITS", "DROPSTATUS",
  "DROPDELIVERED", "FORCEIDLE", "DNS", "SERVICE", "PORT", "UIDL",
  "INTERVAL", "MIMEDECODE", "IDLE", "CHECKALIAS", "SSL", "SSLKEY",
  "SSLCERT", "SSLPROTO", "SSLCERTCK", "SSLCERTFILE", "SSLCERTPATH",
  "SSLCOMMONNAME", "SSLFINGERPRINT", "PRINCIPAL", "ESMTPNAME",
  "ESMTPPASSWORD", "TRACEPOLLS", "$accept", "statement_list", "optmap",
  "statement", "define_server", "serverspecs", "alias_list", "domain_list",
  "serv_option", "userspecs", "explicits", "explicitdef", "userdef",
  "user0opts", "user1opts", "mapping_list", "mapping", "folder_list",
  "smtp_list", "fetch_list", "num_list", "user_option", YY_NULLPTR
  };
  return yy_sname[yysymbol];
}
#endif

#define YYPACT_NINF (-132)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-86)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
      57,  -132,   116,  -132,  -132,   -58,   -32,   283,  -132,  -132,
    -132,  -132,     2,     2,     2,  -132,     2,     2,  -132,     2,
    -132,  -132,  -132,  -132,    88,    -5,  -132,   -16,    -7,    59,
      69,    70,    72,  -132,  -132,  -132,  -132,  -132,  -132,    76,
      85,    86,    33,    90,    89,    91,    56,    87,    94,    96,
      97,    98,   100,   101,   102,  -132,   103,    92,   104,   105,
     106,   113,   114,   115,   117,   119,   120,   121,   122,   123,
     124,   129,   141,   142,   144,   149,   151,    62,   126,  -132,
     152,  -132,  -132,  -132,  -132,  -132,  -132,  -132,  -132,  -132,
    -132,  -132,    66,   153,  -132,   154,  -132,  -132,  -132,  -132,
     156,   157,   158,  -132,   159,   160,   178,   179,   180,   181,
     183,  -132,  -132,    93,   140,  -132,  -132,   210,  -132,  -132,
    -132,  -132,  -132,  -132,  -132,  -132,  -132,   184,  -132,   186,
    -132,  -132,  -132,  -132,  -132,  -132,  -132,   193,  -132,    73,
      68,  -132,  -132,  -132,   194,  -132,   195,  -132,   196,  -132,
    -132,  -132,  -132,  -132,  -132,  -132,   197,  -132,  -132,  -132,
    -132,  -132,  -132,  -132,  -132,    13,    71,   130,    78,  -132,
    -132,  -132,  -132,  -132,  -132,  -132,  -132,  -132,  -132,  -132,
    -132,  -132,  -132,  -132,  -132,  -132,  -132,  -132,  -132,  -132,
    -132,  -132,  -132,  -132,  -132,  -132,  -132,  -132,  -132,  -132,
    -132,  -132,  -132,  -132,  -132,  -132,  -132,  -132,  -132,  -132,
    -132,  -132,    30,  -132,  -132,   210,   239,  -132,  -132,  -132,
    -132,  -132,   199,  -132,  -132,  -132,  -132,  -132,  -132,  -132,
    -132,  -132,  -132,  -132
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,     4,     0,     1,    30,     0,     0,     0,     3,    31,
      28,    29,     6,     6,     6,    19,     6,     6,    21,     6,
      12,    14,    16,    23,     0,    25,     5,     0,     0,     0,
       0,     0,     0,    20,    22,    13,    15,    17,    24,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   111,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   114,
       0,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     127,    64,     0,     0,    46,     0,   125,   126,    48,   128,
       0,     0,     0,   132,     0,     0,     0,     0,     0,     0,
       0,    67,    32,    26,    72,    73,    79,    71,    81,    18,
       7,    10,     8,     9,    11,    38,    33,    37,    35,    39,
      41,    45,    40,    54,    55,    56,    58,     0,    59,    76,
       0,    83,   100,    87,   103,    89,   104,    91,   105,   109,
     110,   101,   102,   106,   107,    93,   108,   112,   113,   152,
     153,    60,    61,    62,    63,    85,    98,    85,    96,   157,
     154,   155,   156,   158,   159,    69,    70,    66,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   149,    65,
      47,   147,   148,    49,   150,   151,    68,   115,    50,    51,
      52,    53,   129,   130,   131,   133,   134,   135,   136,    42,
      43,    44,     0,    27,    74,    75,     0,    82,    34,    36,
      57,    78,     0,    77,    84,    88,    90,    92,    94,    99,
      97,    95,    80,    86
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -132,  -132,    35,  -132,  -132,  -132,  -132,  -132,   150,  -132,
    -132,   155,  -132,  -132,  -132,    80,  -131,  -132,  -132,  -132,
    -132,  -117
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_uint8 yydefgoto[] =
{
       0,     2,    27,     8,     9,    25,   127,   129,   112,   113,
     114,   115,   116,   215,   117,   140,   141,   144,   146,   148,
     156,   118
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     217,    39,    40,    41,    42,    43,    44,    45,    10,   224,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    11,   224,    70,   224,    71,    72,
      73,    74,    75,    76,    26,   177,   130,   131,    28,    29,
     119,    30,    31,   229,    32,   222,    77,    -2,     1,   120,
      -2,    -2,    -2,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   132,   232,    39,
      40,    41,    42,    43,    44,    45,    -2,   223,    46,    47,
     230,   189,   -85,   221,   190,   222,     3,   231,   193,     4,
       5,     6,   136,   137,   175,   176,   121,    65,    66,    67,
      68,   196,   198,   199,   167,   122,   123,   167,   124,   -85,
      33,   177,   125,    34,   167,    35,    36,    37,    38,   166,
     168,   126,   128,   138,    77,   133,   134,    48,   135,   152,
     139,   212,   142,   143,   145,     7,   147,   149,   150,   151,
     153,   154,   222,   155,    91,    92,    93,    94,    95,   157,
     158,    98,   159,     0,   160,   161,   162,   163,   164,   165,
     167,   108,   109,   110,   111,   178,   169,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   170,   171,
     190,   172,   191,   192,   193,   194,   173,   174,   197,   195,
     200,   201,   202,   203,   204,   205,   206,   196,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,   207,   208,   209,   210,    69,   211,
     218,    70,   219,    71,    72,    73,    74,    75,    76,   220,
     225,   226,   227,   213,   228,   233,     0,     0,     0,   214,
       0,     0,     0,     0,     0,     0,     0,     0,   216,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,     0,     0,     0,     0,     0,    96,    97,     0,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   178,     0,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
       0,     0,     0,     0,     0,   191,   192,     0,   194,     0,
       0,    12,   195,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,     0,     0,     0,     0,     0,     0,
       0,    24
};

static const yytype_int16 yycheck[] =
{
     117,     6,     7,     8,     9,    10,    11,    12,    66,   140,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    66,   166,    41,   168,    43,    44,
      45,    46,    47,    48,    42,    15,    13,    14,    13,    14,
      66,    16,    17,    40,    19,    42,    61,     0,     1,    66,
       3,     4,     5,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,    64,   215,     6,
       7,     8,     9,    10,    11,    12,    49,    39,    15,    16,
      39,    81,    39,    40,    84,    42,     0,    39,    88,     3,
       4,     5,    66,    67,    62,    63,    67,    34,    35,    36,
      37,   101,    66,    67,    66,    66,    66,    66,    66,    66,
      52,    15,    66,    55,    66,    57,    58,    59,    60,    69,
      70,    66,    66,    66,    61,    65,    67,    17,    67,    67,
      66,    68,    66,    66,    66,    49,    66,    66,    66,    66,
      66,    66,    42,    67,    81,    82,    83,    84,    85,    66,
      66,    88,    67,    -1,    67,    66,    66,    66,    66,    66,
      66,    98,    99,   100,   101,    69,    67,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    67,    67,
      84,    67,    86,    87,    88,    89,    67,    66,    66,    93,
      67,    67,    66,    66,    66,    66,    66,   101,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    66,    66,    66,    66,    38,    66,
      66,    41,    66,    43,    44,    45,    46,    47,    48,    66,
      66,    66,    66,   113,    67,    66,    -1,    -1,    -1,   114,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    -1,    -1,    -1,    -1,    -1,    86,    87,    -1,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    69,    -1,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      -1,    -1,    -1,    -1,    -1,    86,    87,    -1,    89,    -1,
      -1,    48,    93,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    68
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int8 yystos[] =
{
       0,     1,   103,     0,     3,     4,     5,    49,   105,   106,
      66,    66,    48,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    68,   107,    42,   104,   104,   104,
     104,   104,   104,    52,    55,    57,    58,    59,    60,     6,
       7,     8,     9,    10,    11,    12,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      41,    43,    44,    45,    46,    47,    48,    61,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   110,   111,   112,   113,   114,   116,   123,    66,
      66,    67,    66,    66,    66,    66,    66,   108,    66,   109,
      13,    14,    64,    65,    67,    67,    66,    67,    66,    66,
     117,   118,    66,    66,   119,    66,   120,    66,   121,    66,
      66,    66,    67,    66,    66,    67,   122,    66,    66,    67,
      67,    66,    66,    66,    66,    66,   117,    66,   117,    67,
      67,    67,    67,    67,    66,    62,    63,    15,    69,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      84,    86,    87,    88,    89,    93,   101,    66,    66,    67,
      67,    67,    66,    66,    66,    66,    66,    66,    66,    66,
      66,    66,    68,   110,   113,   115,    68,   123,    66,    66,
      66,    40,    42,    39,   118,    66,    66,    66,    67,    40,
      39,    39,   123,    66
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr1[] =
{
       0,   102,   103,   103,   103,   104,   104,   105,   105,   105,
     105,   105,   105,   105,   105,   105,   105,   105,   105,   105,
     105,   105,   105,   105,   105,   105,   105,   105,   106,   106,
     106,   107,   107,   108,   108,   109,   109,   110,   110,   110,
     110,   110,   110,   110,   110,   110,   110,   110,   110,   110,
     110,   110,   110,   110,   110,   110,   110,   110,   110,   110,
     110,   110,   110,   110,   110,   110,   110,   110,   110,   110,
     110,   111,   111,   112,   112,   113,   114,   114,   114,   115,
     115,   116,   116,   117,   117,   118,   118,   119,   119,   120,
     120,   121,   121,   122,   122,   123,   123,   123,   123,   123,
     123,   123,   123,   123,   123,   123,   123,   123,   123,   123,
     123,   123,   123,   123,   123,   123,   123,   123,   123,   123,
     123,   123,   123,   123,   123,   123,   123,   123,   123,   123,
     123,   123,   123,   123,   123,   123,   123,   123,   123,   123,
     123,   123,   123,   123,   123,   123,   123,   123,   123,   123,
     123,   123,   123,   123,   123,   123,   123,   123,   123,   123
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     0,     2,     1,     1,     0,     4,     4,     4,
       4,     4,     2,     3,     2,     3,     2,     3,     4,     2,
       3,     2,     3,     2,     3,     2,     3,     4,     2,     2,
       1,     0,     2,     1,     2,     1,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     1,     2,
       2,     2,     2,     2,     2,     2,     2,     3,     2,     2,
       2,     2,     2,     2,     1,     2,     2,     1,     2,     2,
       2,     1,     1,     1,     2,     2,     2,     3,     3,     0,
       2,     1,     2,     1,     2,     1,     3,     1,     2,     1,
       2,     1,     2,     1,     2,     3,     2,     3,     2,     3,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     1,     2,     2,     1,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       2,     2,     1,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        YY_LAC_DISCARD ("YYBACKUP");                              \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  switch (yykind)
    {
    case YYSYMBOL_DEFAULTS: /* DEFAULTS  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1286 "rcfile_y.c"
        break;

    case YYSYMBOL_POLL: /* POLL  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1292 "rcfile_y.c"
        break;

    case YYSYMBOL_SKIP: /* SKIP  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1298 "rcfile_y.c"
        break;

    case YYSYMBOL_VIA: /* VIA  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1304 "rcfile_y.c"
        break;

    case YYSYMBOL_AKA: /* AKA  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1310 "rcfile_y.c"
        break;

    case YYSYMBOL_LOCALDOMAINS: /* LOCALDOMAINS  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1316 "rcfile_y.c"
        break;

    case YYSYMBOL_PROTOCOL: /* PROTOCOL  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1322 "rcfile_y.c"
        break;

    case YYSYMBOL_AUTHENTICATE: /* AUTHENTICATE  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1328 "rcfile_y.c"
        break;

    case YYSYMBOL_TIMEOUT: /* TIMEOUT  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1334 "rcfile_y.c"
        break;

    case YYSYMBOL_IDLETIMEOUT: /* IDLETIMEOUT  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1340 "rcfile_y.c"
        break;

    case YYSYMBOL_KPOP: /* KPOP  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1346 "rcfile_y.c"
        break;

    case YYSYMBOL_SDPS: /* SDPS  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1352 "rcfile_y.c"
        break;

    case YYSYMBOL_ENVELOPE: /* ENVELOPE  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1358 "rcfile_y.c"
        break;

    case YYSYMBOL_QVIRTUAL: /* QVIRTUAL  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1364 "rcfile_y.c"
        break;

    case YYSYMBOL_USERNAME: /* USERNAME  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1370 "rcfile_y.c"
        break;

    case YYSYMBOL_PASSWORD: /* PASSWORD  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1376 "rcfile_y.c"
        break;

    case YYSYMBOL_FOLDER: /* FOLDER  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1382 "rcfile_y.c"
        break;

    case YYSYMBOL_SMTPHOST: /* SMTPHOST  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1388 "rcfile_y.c"
        break;

    case YYSYMBOL_FETCHDOMAINS: /* FETCHDOMAINS  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1394 "rcfile_y.c"
        break;

    case YYSYMBOL_MDA: /* MDA  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1400 "rcfile_y.c"
        break;

    case YYSYMBOL_BSMTP: /* BSMTP  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1406 "rcfile_y.c"
        break;

    case YYSYMBOL_LMTP: /* LMTP  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1412 "rcfile_y.c"
        break;

    case YYSYMBOL_PASSWORDFILE: /* PASSWORDFILE  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1418 "rcfile_y.c"
        break;

    case YYSYMBOL_PASSWORDFD: /* PASSWORDFD  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1424 "rcfile_y.c"
        break;

    case YYSYMBOL_SMTPADDRESS: /* SMTPADDRESS  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1430 "rcfile_y.c"
        break;

    case YYSYMBOL_SMTPNAME: /* SMTPNAME  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1436 "rcfile_y.c"
        break;

    case YYSYMBOL_SPAMRESPONSE: /* SPAMRESPONSE  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1442 "rcfile_y.c"
        break;

    case YYSYMBOL_PRECONNECT: /* PRECONNECT  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1448 "rcfile_y.c"
        break;

    case YYSYMBOL_POSTCONNECT: /* POSTCONNECT  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1454 "rcfile_y.c"
        break;

    case YYSYMBOL_LIMIT: /* LIMIT  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1460 "rcfile_y.c"
        break;

    case YYSYMBOL_WARNINGS: /* WARNINGS  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1466 "rcfile_y.c"
        break;

    case YYSYMBOL_INTERFACE: /* INTERFACE  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1472 "rcfile_y.c"
        break;

    case YYSYMBOL_MONITOR: /* MONITOR  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1478 "rcfile_y.c"
        break;

    case YYSYMBOL_PLUGIN: /* PLUGIN  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1484 "rcfile_y.c"
        break;

    case YYSYMBOL_PLUGOUT: /* PLUGOUT  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1490 "rcfile_y.c"
        break;

    case YYSYMBOL_IS: /* IS  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1496 "rcfile_y.c"
        break;

    case YYSYMBOL_HERE: /* HERE  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1502 "rcfile_y.c"
        break;

    case YYSYMBOL_THERE: /* THERE  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1508 "rcfile_y.c"
        break;

    case YYSYMBOL_TO: /* TO  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1514 "rcfile_y.c"
        break;

    case YYSYMBOL_MAP: /* MAP  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1520 "rcfile_y.c"
        break;

    case YYSYMBOL_BATCHLIMIT: /* BATCHLIMIT  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1526 "rcfile_y.c"
        break;

    case YYSYMBOL_FETCHLIMIT: /* FETCHLIMIT  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1532 "rcfile_y.c"
        break;

    case YYSYMBOL_FETCHSIZELIMIT: /* FETCHSIZELIMIT  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1538 "rcfile_y.c"
        break;

    case YYSYMBOL_FASTUIDL: /* FASTUIDL  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1544 "rcfile_y.c"
        break;

    case YYSYMBOL_EXPUNGE: /* EXPUNGE  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1550 "rcfile_y.c"
        break;

    case YYSYMBOL_PROPERTIES: /* PROPERTIES  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1556 "rcfile_y.c"
        break;

    case YYSYMBOL_SET: /* SET  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1562 "rcfile_y.c"
        break;

    case YYSYMBOL_LOGFILE: /* LOGFILE  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1568 "rcfile_y.c"
        break;

    case YYSYMBOL_DAEMON: /* DAEMON  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1574 "rcfile_y.c"
        break;

    case YYSYMBOL_SYSLOG: /* SYSLOG  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1580 "rcfile_y.c"
        break;

    case YYSYMBOL_IDFILE: /* IDFILE  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1586 "rcfile_y.c"
        break;

    case YYSYMBOL_PIDFILE: /* PIDFILE  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1592 "rcfile_y.c"
        break;

    case YYSYMBOL_INVISIBLE: /* INVISIBLE  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1598 "rcfile_y.c"
        break;

    case YYSYMBOL_POSTMASTER: /* POSTMASTER  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1604 "rcfile_y.c"
        break;

    case YYSYMBOL_BOUNCEMAIL: /* BOUNCEMAIL  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1610 "rcfile_y.c"
        break;

    case YYSYMBOL_SPAMBOUNCE: /* SPAMBOUNCE  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1616 "rcfile_y.c"
        break;

    case YYSYMBOL_SOFTBOUNCE: /* SOFTBOUNCE  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1622 "rcfile_y.c"
        break;

    case YYSYMBOL_SHOWDOTS: /* SHOWDOTS  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1628 "rcfile_y.c"
        break;

    case YYSYMBOL_BADHEADER: /* BADHEADER  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1634 "rcfile_y.c"
        break;

    case YYSYMBOL_ACCEPT: /* ACCEPT  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1640 "rcfile_y.c"
        break;

    case YYSYMBOL_REJECT_: /* REJECT_  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1646 "rcfile_y.c"
        break;

    case YYSYMBOL_PROTO: /* PROTO  */
#line 93 "rcfile_y.y"
         { fprintf(yyo, "((proto)(%d))", ((*yyvaluep).proto)); }
#line 1652 "rcfile_y.c"
        break;

    case YYSYMBOL_AUTHTYPE: /* AUTHTYPE  */
#line 93 "rcfile_y.y"
         { fprintf(yyo, "((proto)(%d))", ((*yyvaluep).proto)); }
#line 1658 "rcfile_y.c"
        break;

    case YYSYMBOL_STRING: /* STRING  */
#line 91 "rcfile_y.y"
         { fprintf(yyo, "\"%s\"", ((*yyvaluep).sval)); }
#line 1664 "rcfile_y.c"
        break;

    case YYSYMBOL_NUMBER: /* NUMBER  */
#line 92 "rcfile_y.y"
         { fprintf(yyo, "%d", ((*yyvaluep).number)); }
#line 1670 "rcfile_y.c"
        break;

    case YYSYMBOL_NO: /* NO  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1676 "rcfile_y.c"
        break;

    case YYSYMBOL_KEEP: /* KEEP  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1682 "rcfile_y.c"
        break;

    case YYSYMBOL_MOVETO: /* MOVETO  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1688 "rcfile_y.c"
        break;

    case YYSYMBOL_FLUSH: /* FLUSH  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1694 "rcfile_y.c"
        break;

    case YYSYMBOL_LIMITFLUSH: /* LIMITFLUSH  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1700 "rcfile_y.c"
        break;

    case YYSYMBOL_FETCHALL: /* FETCHALL  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1706 "rcfile_y.c"
        break;

    case YYSYMBOL_REWRITE: /* REWRITE  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1712 "rcfile_y.c"
        break;

    case YYSYMBOL_FORCECR: /* FORCECR  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1718 "rcfile_y.c"
        break;

    case YYSYMBOL_STRIPCR: /* STRIPCR  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1724 "rcfile_y.c"
        break;

    case YYSYMBOL_PASS8BITS: /* PASS8BITS  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1730 "rcfile_y.c"
        break;

    case YYSYMBOL_DROPSTATUS: /* DROPSTATUS  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1736 "rcfile_y.c"
        break;

    case YYSYMBOL_DROPDELIVERED: /* DROPDELIVERED  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1742 "rcfile_y.c"
        break;

    case YYSYMBOL_FORCEIDLE: /* FORCEIDLE  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1748 "rcfile_y.c"
        break;

    case YYSYMBOL_DNS: /* DNS  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1754 "rcfile_y.c"
        break;

    case YYSYMBOL_SERVICE: /* SERVICE  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1760 "rcfile_y.c"
        break;

    case YYSYMBOL_PORT: /* PORT  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1766 "rcfile_y.c"
        break;

    case YYSYMBOL_UIDL: /* UIDL  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1772 "rcfile_y.c"
        break;

    case YYSYMBOL_INTERVAL: /* INTERVAL  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1778 "rcfile_y.c"
        break;

    case YYSYMBOL_MIMEDECODE: /* MIMEDECODE  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1784 "rcfile_y.c"
        break;

    case YYSYMBOL_IDLE: /* IDLE  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1790 "rcfile_y.c"
        break;

    case YYSYMBOL_CHECKALIAS: /* CHECKALIAS  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1796 "rcfile_y.c"
        break;

    case YYSYMBOL_SSL: /* SSL  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1802 "rcfile_y.c"
        break;

    case YYSYMBOL_SSLKEY: /* SSLKEY  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1808 "rcfile_y.c"
        break;

    case YYSYMBOL_SSLCERT: /* SSLCERT  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1814 "rcfile_y.c"
        break;

    case YYSYMBOL_SSLPROTO: /* SSLPROTO  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1820 "rcfile_y.c"
        break;

    case YYSYMBOL_SSLCERTCK: /* SSLCERTCK  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1826 "rcfile_y.c"
        break;

    case YYSYMBOL_SSLCERTFILE: /* SSLCERTFILE  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1832 "rcfile_y.c"
        break;

    case YYSYMBOL_SSLCERTPATH: /* SSLCERTPATH  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1838 "rcfile_y.c"
        break;

    case YYSYMBOL_SSLCOMMONNAME: /* SSLCOMMONNAME  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1844 "rcfile_y.c"
        break;

    case YYSYMBOL_SSLFINGERPRINT: /* SSLFINGERPRINT  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1850 "rcfile_y.c"
        break;

    case YYSYMBOL_PRINCIPAL: /* PRINCIPAL  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1856 "rcfile_y.c"
        break;

    case YYSYMBOL_ESMTPNAME: /* ESMTPNAME  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1862 "rcfile_y.c"
        break;

    case YYSYMBOL_ESMTPPASSWORD: /* ESMTPPASSWORD  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1868 "rcfile_y.c"
        break;

    case YYSYMBOL_TRACEPOLLS: /* TRACEPOLLS  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1874 "rcfile_y.c"
        break;

    case YYSYMBOL_statement_list: /* statement_list  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1880 "rcfile_y.c"
        break;

    case YYSYMBOL_optmap: /* optmap  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1886 "rcfile_y.c"
        break;

    case YYSYMBOL_statement: /* statement  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1892 "rcfile_y.c"
        break;

    case YYSYMBOL_define_server: /* define_server  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1898 "rcfile_y.c"
        break;

    case YYSYMBOL_serverspecs: /* serverspecs  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1904 "rcfile_y.c"
        break;

    case YYSYMBOL_alias_list: /* alias_list  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1910 "rcfile_y.c"
        break;

    case YYSYMBOL_domain_list: /* domain_list  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1916 "rcfile_y.c"
        break;

    case YYSYMBOL_serv_option: /* serv_option  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1922 "rcfile_y.c"
        break;

    case YYSYMBOL_userspecs: /* userspecs  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1928 "rcfile_y.c"
        break;

    case YYSYMBOL_explicits: /* explicits  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1934 "rcfile_y.c"
        break;

    case YYSYMBOL_explicitdef: /* explicitdef  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1940 "rcfile_y.c"
        break;

    case YYSYMBOL_userdef: /* userdef  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1946 "rcfile_y.c"
        break;

    case YYSYMBOL_user0opts: /* user0opts  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1952 "rcfile_y.c"
        break;

    case YYSYMBOL_user1opts: /* user1opts  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1958 "rcfile_y.c"
        break;

    case YYSYMBOL_mapping_list: /* mapping_list  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1964 "rcfile_y.c"
        break;

    case YYSYMBOL_mapping: /* mapping  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1970 "rcfile_y.c"
        break;

    case YYSYMBOL_folder_list: /* folder_list  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1976 "rcfile_y.c"
        break;

    case YYSYMBOL_smtp_list: /* smtp_list  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1982 "rcfile_y.c"
        break;

    case YYSYMBOL_fetch_list: /* fetch_list  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1988 "rcfile_y.c"
        break;

    case YYSYMBOL_num_list: /* num_list  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 1994 "rcfile_y.c"
        break;

    case YYSYMBOL_user_option: /* user_option  */
#line 94 "rcfile_y.y"
         { fprintf(yyo, "<>"); }
#line 2000 "rcfile_y.c"
        break;

      default:
        break;
    }
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


/* Given a state stack such that *YYBOTTOM is its bottom, such that
   *YYTOP is either its top or is YYTOP_EMPTY to indicate an empty
   stack, and such that *YYCAPACITY is the maximum number of elements it
   can hold without a reallocation, make sure there is enough room to
   store YYADD more elements.  If not, allocate a new stack using
   YYSTACK_ALLOC, copy the existing elements, and adjust *YYBOTTOM,
   *YYTOP, and *YYCAPACITY to reflect the new capacity and memory
   location.  If *YYBOTTOM != YYBOTTOM_NO_FREE, then free the old stack
   using YYSTACK_FREE.  Return 0 if successful or if no reallocation is
   required.  Return YYENOMEM if memory is exhausted.  */
static int
yy_lac_stack_realloc (YYPTRDIFF_T *yycapacity, YYPTRDIFF_T yyadd,
#if YYDEBUG
                      char const *yydebug_prefix,
                      char const *yydebug_suffix,
#endif
                      yy_state_t **yybottom,
                      yy_state_t *yybottom_no_free,
                      yy_state_t **yytop, yy_state_t *yytop_empty)
{
  YYPTRDIFF_T yysize_old =
    *yytop == yytop_empty ? 0 : *yytop - *yybottom + 1;
  YYPTRDIFF_T yysize_new = yysize_old + yyadd;
  if (*yycapacity < yysize_new)
    {
      YYPTRDIFF_T yyalloc = 2 * yysize_new;
      yy_state_t *yybottom_new;
      /* Use YYMAXDEPTH for maximum stack size given that the stack
         should never need to grow larger than the main state stack
         needs to grow without LAC.  */
      if (YYMAXDEPTH < yysize_new)
        {
          YYDPRINTF ((stderr, "%smax size exceeded%s", yydebug_prefix,
                      yydebug_suffix));
          return YYENOMEM;
        }
      if (YYMAXDEPTH < yyalloc)
        yyalloc = YYMAXDEPTH;
      yybottom_new =
        YY_CAST (yy_state_t *,
                 YYSTACK_ALLOC (YY_CAST (YYSIZE_T,
                                         yyalloc * YYSIZEOF (*yybottom_new))));
      if (!yybottom_new)
        {
          YYDPRINTF ((stderr, "%srealloc failed%s", yydebug_prefix,
                      yydebug_suffix));
          return YYENOMEM;
        }
      if (*yytop != yytop_empty)
        {
          YYCOPY (yybottom_new, *yybottom, yysize_old);
          *yytop = yybottom_new + (yysize_old - 1);
        }
      if (*yybottom != yybottom_no_free)
        YYSTACK_FREE (*yybottom);
      *yybottom = yybottom_new;
      *yycapacity = yyalloc;
    }
  return 0;
}

/* Establish the initial context for the current lookahead if no initial
   context is currently established.

   We define a context as a snapshot of the parser stacks.  We define
   the initial context for a lookahead as the context in which the
   parser initially examines that lookahead in order to select a
   syntactic action.  Thus, if the lookahead eventually proves
   syntactically unacceptable (possibly in a later context reached via a
   series of reductions), the initial context can be used to determine
   the exact set of tokens that would be syntactically acceptable in the
   lookahead's place.  Moreover, it is the context after which any
   further semantic actions would be erroneous because they would be
   determined by a syntactically unacceptable token.

   YY_LAC_ESTABLISH should be invoked when a reduction is about to be
   performed in an inconsistent state (which, for the purposes of LAC,
   includes consistent states that don't know they're consistent because
   their default reductions have been disabled).  Iff there is a
   lookahead token, it should also be invoked before reporting a syntax
   error.  This latter case is for the sake of the debugging output.

   For parse.lac=full, the implementation of YY_LAC_ESTABLISH is as
   follows.  If no initial context is currently established for the
   current lookahead, then check if that lookahead can eventually be
   shifted if syntactic actions continue from the current context.
   Report a syntax error if it cannot.  */
#define YY_LAC_ESTABLISH                                                \
do {                                                                    \
  if (!yy_lac_established)                                              \
    {                                                                   \
      YYDPRINTF ((stderr,                                               \
                  "LAC: initial context established for %s\n",          \
                  yysymbol_name (yytoken)));                            \
      yy_lac_established = 1;                                           \
      switch (yy_lac (yyesa, &yyes, &yyes_capacity, yyssp, yytoken))    \
        {                                                               \
        case YYENOMEM:                                                  \
          YYNOMEM;                                                      \
        case 1:                                                         \
          goto yyerrlab;                                                \
        }                                                               \
    }                                                                   \
} while (0)

/* Discard any previous initial lookahead context because of Event,
   which may be a lookahead change or an invalidation of the currently
   established initial context for the current lookahead.

   The most common example of a lookahead change is a shift.  An example
   of both cases is syntax error recovery.  That is, a syntax error
   occurs when the lookahead is syntactically erroneous for the
   currently established initial context, so error recovery manipulates
   the parser stacks to try to find a new initial context in which the
   current lookahead is syntactically acceptable.  If it fails to find
   such a context, it discards the lookahead.  */
#if YYDEBUG
# define YY_LAC_DISCARD(Event)                                           \
do {                                                                     \
  if (yy_lac_established)                                                \
    {                                                                    \
      YYDPRINTF ((stderr, "LAC: initial context discarded due to "       \
                  Event "\n"));                                          \
      yy_lac_established = 0;                                            \
    }                                                                    \
} while (0)
#else
# define YY_LAC_DISCARD(Event) yy_lac_established = 0
#endif

/* Given the stack whose top is *YYSSP, return 0 iff YYTOKEN can
   eventually (after perhaps some reductions) be shifted, return 1 if
   not, or return YYENOMEM if memory is exhausted.  As preconditions and
   postconditions: *YYES_CAPACITY is the allocated size of the array to
   which *YYES points, and either *YYES = YYESA or *YYES points to an
   array allocated with YYSTACK_ALLOC.  yy_lac may overwrite the
   contents of either array, alter *YYES and *YYES_CAPACITY, and free
   any old *YYES other than YYESA.  */
static int
yy_lac (yy_state_t *yyesa, yy_state_t **yyes,
        YYPTRDIFF_T *yyes_capacity, yy_state_t *yyssp, yysymbol_kind_t yytoken)
{
  yy_state_t *yyes_prev = yyssp;
  yy_state_t *yyesp = yyes_prev;
  /* Reduce until we encounter a shift and thereby accept the token.  */
  YYDPRINTF ((stderr, "LAC: checking lookahead %s:", yysymbol_name (yytoken)));
  if (yytoken == YYSYMBOL_YYUNDEF)
    {
      YYDPRINTF ((stderr, " Always Err\n"));
      return 1;
    }
  while (1)
    {
      int yyrule = yypact[+*yyesp];
      if (yypact_value_is_default (yyrule)
          || (yyrule += yytoken) < 0 || YYLAST < yyrule
          || yycheck[yyrule] != yytoken)
        {
          /* Use the default action.  */
          yyrule = yydefact[+*yyesp];
          if (yyrule == 0)
            {
              YYDPRINTF ((stderr, " Err\n"));
              return 1;
            }
        }
      else
        {
          /* Use the action from yytable.  */
          yyrule = yytable[yyrule];
          if (yytable_value_is_error (yyrule))
            {
              YYDPRINTF ((stderr, " Err\n"));
              return 1;
            }
          if (0 < yyrule)
            {
              YYDPRINTF ((stderr, " S%d\n", yyrule));
              return 0;
            }
          yyrule = -yyrule;
        }
      /* By now we know we have to simulate a reduce.  */
      YYDPRINTF ((stderr, " R%d", yyrule - 1));
      {
        /* Pop the corresponding number of values from the stack.  */
        YYPTRDIFF_T yylen = yyr2[yyrule];
        /* First pop from the LAC stack as many tokens as possible.  */
        if (yyesp != yyes_prev)
          {
            YYPTRDIFF_T yysize = yyesp - *yyes + 1;
            if (yylen < yysize)
              {
                yyesp -= yylen;
                yylen = 0;
              }
            else
              {
                yyesp = yyes_prev;
                yylen -= yysize;
              }
          }
        /* Only afterwards look at the main stack.  */
        if (yylen)
          yyesp = yyes_prev -= yylen;
      }
      /* Push the resulting state of the reduction.  */
      {
        yy_state_fast_t yystate;
        {
          const int yylhs = yyr1[yyrule] - YYNTOKENS;
          const int yyi = yypgoto[yylhs] + *yyesp;
          yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyesp
                     ? yytable[yyi]
                     : yydefgoto[yylhs]);
        }
        if (yyesp == yyes_prev)
          {
            yyesp = *yyes;
            YY_IGNORE_USELESS_CAST_BEGIN
            *yyesp = YY_CAST (yy_state_t, yystate);
            YY_IGNORE_USELESS_CAST_END
          }
        else
          {
            if (yy_lac_stack_realloc (yyes_capacity, 1,
#if YYDEBUG
                                      " (", ")",
#endif
                                      yyes, yyesa, &yyesp, yyes_prev))
              {
                YYDPRINTF ((stderr, "\n"));
                return YYENOMEM;
              }
            YY_IGNORE_USELESS_CAST_BEGIN
            *++yyesp = YY_CAST (yy_state_t, yystate);
            YY_IGNORE_USELESS_CAST_END
          }
        YYDPRINTF ((stderr, " G%d", yystate));
      }
    }
}

/* Context of a parse error.  */
typedef struct
{
  yy_state_t *yyssp;
  yy_state_t *yyesa;
  yy_state_t **yyes;
  YYPTRDIFF_T *yyes_capacity;
  yysymbol_kind_t yytoken;
} yypcontext_t;

/* Put in YYARG at most YYARGN of the expected tokens given the
   current YYCTX, and return the number of tokens stored in YYARG.  If
   YYARG is null, return the number of expected tokens (guaranteed to
   be less than YYNTOKENS).  Return YYENOMEM on memory exhaustion.
   Return 0 if there are more than YYARGN expected tokens, yet fill
   YYARG up to YYARGN. */
static int
yypcontext_expected_tokens (const yypcontext_t *yyctx,
                            yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;

  int yyx;
  for (yyx = 0; yyx < YYNTOKENS; ++yyx)
    {
      yysymbol_kind_t yysym = YY_CAST (yysymbol_kind_t, yyx);
      if (yysym != YYSYMBOL_YYerror && yysym != YYSYMBOL_YYUNDEF)
        switch (yy_lac (yyctx->yyesa, yyctx->yyes, yyctx->yyes_capacity, yyctx->yyssp, yysym))
          {
          case YYENOMEM:
            return YYENOMEM;
          case 1:
            continue;
          default:
            if (!yyarg)
              ++yycount;
            else if (yycount == yyargn)
              return 0;
            else
              yyarg[yycount++] = yysym;
          }
    }
  if (yyarg && yycount == 0 && 0 < yyargn)
    yyarg[0] = YYSYMBOL_YYEMPTY;
  return yycount;
}




#ifndef yystrlen
# if defined __GLIBC__ && defined _STRING_H
#  define yystrlen(S) (YY_CAST (YYPTRDIFF_T, strlen (S)))
# else
/* Return the length of YYSTR.  */
static YYPTRDIFF_T
yystrlen (const char *yystr)
{
  YYPTRDIFF_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
# endif
#endif

#ifndef yystpcpy
# if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#  define yystpcpy stpcpy
# else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
# endif
#endif



static int
yy_syntax_error_arguments (const yypcontext_t *yyctx,
                           yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
       In the first two cases, it might appear that the current syntax
       error should have been detected in the previous state when yy_lac
       was invoked.  However, at that time, there might have been a
       different syntax error that discarded a different initial context
       during error recovery, leaving behind the current lookahead.
  */
  if (yyctx->yytoken != YYSYMBOL_YYEMPTY)
    {
      int yyn;
      YYDPRINTF ((stderr, "Constructing syntax error message\n"));
      if (yyarg)
        yyarg[yycount] = yyctx->yytoken;
      ++yycount;
      yyn = yypcontext_expected_tokens (yyctx,
                                        yyarg ? yyarg + 1 : yyarg, yyargn - 1);
      if (yyn == YYENOMEM)
        return YYENOMEM;
      else if (yyn == 0)
        YYDPRINTF ((stderr, "No expected tokens.\n"));
      else
        yycount += yyn;
    }
  return yycount;
}

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.  In order to see if a particular token T is a
   valid looakhead, invoke yy_lac (YYESA, YYES, YYES_CAPACITY, YYSSP, T).

   Return 0 if *YYMSG was successfully written.  Return -1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return YYENOMEM if the
   required number of bytes is too large to store or if
   yy_lac returned YYENOMEM.  */
static int
yysyntax_error (YYPTRDIFF_T *yymsg_alloc, char **yymsg,
                const yypcontext_t *yyctx)
{
  enum { YYARGS_MAX = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat: reported tokens (one for the "unexpected",
     one per "expected"). */
  yysymbol_kind_t yyarg[YYARGS_MAX];
  /* Cumulated lengths of YYARG.  */
  YYPTRDIFF_T yysize = 0;

  /* Actual size of YYARG. */
  int yycount = yy_syntax_error_arguments (yyctx, yyarg, YYARGS_MAX);
  if (yycount == YYENOMEM)
    return YYENOMEM;

  switch (yycount)
    {
#define YYCASE_(N, S)                       \
      case N:                               \
        yyformat = S;                       \
        break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
    }

  /* Compute error message size.  Don't count the "%s"s, but reserve
     room for the terminator.  */
  yysize = yystrlen (yyformat) - 2 * yycount + 1;
  {
    int yyi;
    for (yyi = 0; yyi < yycount; ++yyi)
      {
        YYPTRDIFF_T yysize1
          = yysize + yystrlen (yysymbol_name (yyarg[yyi]));
        if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
          yysize = yysize1;
        else
          return YYENOMEM;
      }
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return -1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp = yystpcpy (yyp, yysymbol_name (yyarg[yyi++]));
          yyformat += 2;
        }
      else
        {
          ++yyp;
          ++yyformat;
        }
  }
  return 0;
}


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  switch (yykind)
    {
    case YYSYMBOL_STRING: /* STRING  */
#line 85 "rcfile_y.y"
            { free (((*yyvaluep).sval)); }
#line 2594 "rcfile_y.c"
        break;

      default:
        break;
    }
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

    yy_state_t yyesa[20];
    yy_state_t *yyes = yyesa;
    YYPTRDIFF_T yyes_capacity = 20 < YYMAXDEPTH ? 20 : YYMAXDEPTH;

  /* Whether LAC context is established.  A Boolean.  */
  int yy_lac_established = 0;
  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYPTRDIFF_T yymsg_alloc = sizeof yymsgbuf;

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    {
      YY_LAC_ESTABLISH;
      goto yydefault;
    }
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      YY_LAC_ESTABLISH;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  YY_LAC_DISCARD ("shift");
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  {
    int yychar_backup = yychar;
    switch (yyn)
      {
  case 7: /* statement: SET LOGFILE optmap STRING  */
#line 106 "rcfile_y.y"
                                                {run.logfile = prependdir ((yyvsp[0].sval), rcfiledir); free((yyvsp[0].sval));}
#line 2880 "rcfile_y.c"
    break;

  case 8: /* statement: SET IDFILE optmap STRING  */
#line 107 "rcfile_y.y"
                                                {run.idfile = prependdir ((yyvsp[0].sval), rcfiledir); free((yyvsp[0].sval));}
#line 2886 "rcfile_y.c"
    break;

  case 9: /* statement: SET PIDFILE optmap STRING  */
#line 108 "rcfile_y.y"
                                                {run.pidfile = prependdir ((yyvsp[0].sval), rcfiledir); free((yyvsp[0].sval));}
#line 2892 "rcfile_y.c"
    break;

  case 10: /* statement: SET DAEMON optmap NUMBER  */
#line 109 "rcfile_y.y"
                                                {run.poll_interval = (yyvsp[0].number);}
#line 2898 "rcfile_y.c"
    break;

  case 11: /* statement: SET POSTMASTER optmap STRING  */
#line 110 "rcfile_y.y"
                                                {run.postmaster = (yyvsp[0].sval);}
#line 2904 "rcfile_y.c"
    break;

  case 12: /* statement: SET BOUNCEMAIL  */
#line 111 "rcfile_y.y"
                                                {run.bouncemail = TRUE;}
#line 2910 "rcfile_y.c"
    break;

  case 13: /* statement: SET NO BOUNCEMAIL  */
#line 112 "rcfile_y.y"
                                                {run.bouncemail = FALSE;}
#line 2916 "rcfile_y.c"
    break;

  case 14: /* statement: SET SPAMBOUNCE  */
#line 113 "rcfile_y.y"
                                                {run.spambounce = TRUE;}
#line 2922 "rcfile_y.c"
    break;

  case 15: /* statement: SET NO SPAMBOUNCE  */
#line 114 "rcfile_y.y"
                                                {run.spambounce = FALSE;}
#line 2928 "rcfile_y.c"
    break;

  case 16: /* statement: SET SOFTBOUNCE  */
#line 115 "rcfile_y.y"
                                                {run.softbounce = TRUE;}
#line 2934 "rcfile_y.c"
    break;

  case 17: /* statement: SET NO SOFTBOUNCE  */
#line 116 "rcfile_y.y"
                                                {run.softbounce = FALSE;}
#line 2940 "rcfile_y.c"
    break;

  case 18: /* statement: SET PROPERTIES optmap STRING  */
#line 117 "rcfile_y.y"
                                                {run.properties = (yyvsp[0].sval);}
#line 2946 "rcfile_y.c"
    break;

  case 19: /* statement: SET SYSLOG  */
#line 118 "rcfile_y.y"
                                                {run.use_syslog = TRUE;}
#line 2952 "rcfile_y.c"
    break;

  case 20: /* statement: SET NO SYSLOG  */
#line 119 "rcfile_y.y"
                                                {run.use_syslog = FALSE;}
#line 2958 "rcfile_y.c"
    break;

  case 21: /* statement: SET INVISIBLE  */
#line 120 "rcfile_y.y"
                                                {run.invisible = TRUE;}
#line 2964 "rcfile_y.c"
    break;

  case 22: /* statement: SET NO INVISIBLE  */
#line 121 "rcfile_y.y"
                                                {run.invisible = FALSE;}
#line 2970 "rcfile_y.c"
    break;

  case 23: /* statement: SET SHOWDOTS  */
#line 122 "rcfile_y.y"
                                                {run.showdots = FLAG_TRUE;}
#line 2976 "rcfile_y.c"
    break;

  case 24: /* statement: SET NO SHOWDOTS  */
#line 123 "rcfile_y.y"
                                                {run.showdots = FLAG_FALSE;}
#line 2982 "rcfile_y.c"
    break;

  case 25: /* statement: define_server serverspecs  */
#line 131 "rcfile_y.y"
                                                        {record_current();}
#line 2988 "rcfile_y.c"
    break;

  case 27: /* statement: define_server serverspecs userspecs serv_option  */
#line 136 "rcfile_y.y"
                        {yyerror(GT_("server option after user options")); yyerrok; }
#line 2994 "rcfile_y.c"
    break;

  case 28: /* define_server: POLL STRING  */
#line 139 "rcfile_y.y"
                                        {reset_server((yyvsp[0].sval), FALSE); free((yyvsp[0].sval));}
#line 3000 "rcfile_y.c"
    break;

  case 29: /* define_server: SKIP STRING  */
#line 140 "rcfile_y.y"
                                        {reset_server((yyvsp[0].sval), TRUE);  free((yyvsp[0].sval));}
#line 3006 "rcfile_y.c"
    break;

  case 30: /* define_server: DEFAULTS  */
#line 141 "rcfile_y.y"
                                        {reset_server("defaults", FALSE);}
#line 3012 "rcfile_y.c"
    break;

  case 33: /* alias_list: STRING  */
#line 148 "rcfile_y.y"
                                        {save_str(&current.server.akalist,(yyvsp[0].sval),0); free((yyvsp[0].sval));}
#line 3018 "rcfile_y.c"
    break;

  case 34: /* alias_list: alias_list STRING  */
#line 149 "rcfile_y.y"
                                        {save_str(&current.server.akalist,(yyvsp[0].sval),0); free((yyvsp[0].sval));}
#line 3024 "rcfile_y.c"
    break;

  case 35: /* domain_list: STRING  */
#line 152 "rcfile_y.y"
                                        {save_str(&current.server.localdomains,(yyvsp[0].sval),0); free((yyvsp[0].sval));}
#line 3030 "rcfile_y.c"
    break;

  case 36: /* domain_list: domain_list STRING  */
#line 153 "rcfile_y.y"
                                        {save_str(&current.server.localdomains,(yyvsp[0].sval),0); free((yyvsp[0].sval));}
#line 3036 "rcfile_y.c"
    break;

  case 38: /* serv_option: VIA STRING  */
#line 157 "rcfile_y.y"
                                        {current.server.via = (yyvsp[0].sval);}
#line 3042 "rcfile_y.c"
    break;

  case 40: /* serv_option: PROTOCOL PROTO  */
#line 159 "rcfile_y.y"
                                        {current.server.protocol = (yyvsp[0].proto);}
#line 3048 "rcfile_y.c"
    break;

  case 41: /* serv_option: PROTOCOL KPOP  */
#line 160 "rcfile_y.y"
                                        {
					    current.server.protocol = P_POP3;

					    if (current.server.authenticate == A_PASSWORD)
#ifdef KERBEROS_V5
						current.server.authenticate = A_KERBEROS_V5;
#else
						current.server.authenticate = A_KERBEROS_V4;
#endif /* KERBEROS_V5 */
					    current.server.service = KPOP_PORT;
					}
#line 3064 "rcfile_y.c"
    break;

  case 42: /* serv_option: PRINCIPAL STRING  */
#line 171 "rcfile_y.y"
                                        {current.server.principal = (yyvsp[0].sval);}
#line 3070 "rcfile_y.c"
    break;

  case 43: /* serv_option: ESMTPNAME STRING  */
#line 172 "rcfile_y.y"
                                        {current.server.esmtp_name = (yyvsp[0].sval);}
#line 3076 "rcfile_y.c"
    break;

  case 44: /* serv_option: ESMTPPASSWORD STRING  */
#line 173 "rcfile_y.y"
                                        {current.server.esmtp_password = (yyvsp[0].sval);}
#line 3082 "rcfile_y.c"
    break;

  case 45: /* serv_option: PROTOCOL SDPS  */
#line 174 "rcfile_y.y"
                                        {
#ifdef SDPS_ENABLE
					    current.server.protocol = P_POP3;
					    current.server.sdps = TRUE;
#else
					    yyerror(GT_("SDPS not enabled."));
#endif /* SDPS_ENABLE */
					}
#line 3095 "rcfile_y.c"
    break;

  case 46: /* serv_option: UIDL  */
#line 182 "rcfile_y.y"
                                        {current.server.uidl = FLAG_TRUE;}
#line 3101 "rcfile_y.c"
    break;

  case 47: /* serv_option: NO UIDL  */
#line 183 "rcfile_y.y"
                                        {current.server.uidl  = FLAG_FALSE;}
#line 3107 "rcfile_y.c"
    break;

  case 48: /* serv_option: CHECKALIAS  */
#line 184 "rcfile_y.y"
                                        {current.server.checkalias = FLAG_TRUE;}
#line 3113 "rcfile_y.c"
    break;

  case 49: /* serv_option: NO CHECKALIAS  */
#line 185 "rcfile_y.y"
                                        {current.server.checkalias  = FLAG_FALSE;}
#line 3119 "rcfile_y.c"
    break;

  case 50: /* serv_option: SERVICE STRING  */
#line 186 "rcfile_y.y"
                                        {
					current.server.service = (yyvsp[0].sval);
					}
#line 3127 "rcfile_y.c"
    break;

  case 51: /* serv_option: SERVICE NUMBER  */
#line 189 "rcfile_y.y"
                                        {
					int port = (yyvsp[0].number);
					char buf[10];
					snprintf(buf, sizeof buf, "%d", port);
					current.server.service = xstrdup(buf);
		}
#line 3138 "rcfile_y.c"
    break;

  case 52: /* serv_option: PORT NUMBER  */
#line 195 "rcfile_y.y"
                                        {
					int port = (yyvsp[0].number);
					char buf[10];
					snprintf(buf, sizeof buf, "%d", port);
					current.server.service = xstrdup(buf);
		}
#line 3149 "rcfile_y.c"
    break;

  case 53: /* serv_option: INTERVAL NUMBER  */
#line 202 "rcfile_y.y"
                        {current.server.interval = (yyvsp[0].number);}
#line 3155 "rcfile_y.c"
    break;

  case 54: /* serv_option: AUTHENTICATE AUTHTYPE  */
#line 204 "rcfile_y.y"
                        {current.server.authenticate = (yyvsp[0].proto);}
#line 3161 "rcfile_y.c"
    break;

  case 55: /* serv_option: TIMEOUT NUMBER  */
#line 206 "rcfile_y.y"
                        {current.server.timeout = (yyvsp[0].number);}
#line 3167 "rcfile_y.c"
    break;

  case 56: /* serv_option: IDLETIMEOUT NUMBER  */
#line 208 "rcfile_y.y"
                        {current.server.idle_timeout = (yyvsp[0].number);}
#line 3173 "rcfile_y.c"
    break;

  case 57: /* serv_option: ENVELOPE NUMBER STRING  */
#line 210 "rcfile_y.y"
                                        {
					    current.server.envelope = (yyvsp[0].sval);
					    current.server.envskip = (yyvsp[-1].number);
					}
#line 3182 "rcfile_y.c"
    break;

  case 58: /* serv_option: ENVELOPE STRING  */
#line 215 "rcfile_y.y"
                                        {
					    current.server.envelope = (yyvsp[0].sval);
					    current.server.envskip = 0;
					}
#line 3191 "rcfile_y.c"
    break;

  case 59: /* serv_option: QVIRTUAL STRING  */
#line 220 "rcfile_y.y"
                                        {current.server.qvirtual = (yyvsp[0].sval);}
#line 3197 "rcfile_y.c"
    break;

  case 60: /* serv_option: INTERFACE STRING  */
#line 221 "rcfile_y.y"
                                        {
#ifdef CAN_MONITOR
					interface_parse((yyvsp[0].sval), &current.server);
#else
					fprintf(stderr, GT_("fetchmail: interface option is only supported under Linux (without IPv6) and FreeBSD\n"));
#endif
					free((yyvsp[0].sval));
					}
#line 3210 "rcfile_y.c"
    break;

  case 61: /* serv_option: MONITOR STRING  */
#line 229 "rcfile_y.y"
                                        {
#ifdef CAN_MONITOR
					current.server.monitor = (yyvsp[0].sval);
#else
					fprintf(stderr, GT_("fetchmail: monitor option is only supported under Linux (without IPv6) and FreeBSD\n"));
					free((yyvsp[0].sval));
#endif
					}
#line 3223 "rcfile_y.c"
    break;

  case 62: /* serv_option: PLUGIN STRING  */
#line 237 "rcfile_y.y"
                                        { current.server.plugin = (yyvsp[0].sval); }
#line 3229 "rcfile_y.c"
    break;

  case 63: /* serv_option: PLUGOUT STRING  */
#line 238 "rcfile_y.y"
                                        { current.server.plugout = (yyvsp[0].sval); }
#line 3235 "rcfile_y.c"
    break;

  case 64: /* serv_option: DNS  */
#line 239 "rcfile_y.y"
                                        {current.server.dns = FLAG_TRUE;}
#line 3241 "rcfile_y.c"
    break;

  case 65: /* serv_option: NO DNS  */
#line 240 "rcfile_y.y"
                                        {current.server.dns = FLAG_FALSE;}
#line 3247 "rcfile_y.c"
    break;

  case 66: /* serv_option: NO ENVELOPE  */
#line 241 "rcfile_y.y"
                                        {current.server.envelope = STRING_DISABLED;}
#line 3253 "rcfile_y.c"
    break;

  case 67: /* serv_option: TRACEPOLLS  */
#line 242 "rcfile_y.y"
                                        {current.server.tracepolls = FLAG_TRUE;}
#line 3259 "rcfile_y.c"
    break;

  case 68: /* serv_option: NO TRACEPOLLS  */
#line 243 "rcfile_y.y"
                                        {current.server.tracepolls = FLAG_FALSE;}
#line 3265 "rcfile_y.c"
    break;

  case 69: /* serv_option: BADHEADER ACCEPT  */
#line 244 "rcfile_y.y"
                                        {current.server.badheader = BHACCEPT;}
#line 3271 "rcfile_y.c"
    break;

  case 70: /* serv_option: BADHEADER REJECT_  */
#line 245 "rcfile_y.y"
                                        {current.server.badheader = BHREJECT;}
#line 3277 "rcfile_y.c"
    break;

  case 71: /* userspecs: user1opts  */
#line 248 "rcfile_y.y"
                                        {record_current(); user_reset();}
#line 3283 "rcfile_y.c"
    break;

  case 73: /* explicits: explicitdef  */
#line 252 "rcfile_y.y"
                                        {record_current(); user_reset();}
#line 3289 "rcfile_y.c"
    break;

  case 74: /* explicits: explicits explicitdef  */
#line 253 "rcfile_y.y"
                                        {record_current(); user_reset();}
#line 3295 "rcfile_y.c"
    break;

  case 76: /* userdef: USERNAME STRING  */
#line 259 "rcfile_y.y"
                                        {current.remotename = (yyvsp[0].sval);}
#line 3301 "rcfile_y.c"
    break;

  case 78: /* userdef: USERNAME STRING THERE  */
#line 261 "rcfile_y.y"
                                        {current.remotename = (yyvsp[-1].sval);}
#line 3307 "rcfile_y.c"
    break;

  case 85: /* mapping: STRING  */
#line 276 "rcfile_y.y"
                                        {if (0 == strcmp((yyvsp[0].sval), "*")) {
					      current.wildcard = TRUE;
					  } else {
					    save_str_pair(&current.localnames, (yyvsp[0].sval), NULL);
					  }
					 free((yyvsp[0].sval));}
#line 3318 "rcfile_y.c"
    break;

  case 86: /* mapping: STRING MAP STRING  */
#line 282 "rcfile_y.y"
                                        {save_str_pair(&current.localnames, (yyvsp[-2].sval), (yyvsp[0].sval)); free((yyvsp[-2].sval)); free((yyvsp[0].sval));}
#line 3324 "rcfile_y.c"
    break;

  case 87: /* folder_list: STRING  */
#line 285 "rcfile_y.y"
                                        {save_str(&current.mailboxes,(yyvsp[0].sval),0); free((yyvsp[0].sval));}
#line 3330 "rcfile_y.c"
    break;

  case 88: /* folder_list: folder_list STRING  */
#line 286 "rcfile_y.y"
                                        {save_str(&current.mailboxes,(yyvsp[0].sval),0); free((yyvsp[0].sval));}
#line 3336 "rcfile_y.c"
    break;

  case 89: /* smtp_list: STRING  */
#line 289 "rcfile_y.y"
                                        {save_str(&current.smtphunt, (yyvsp[0].sval),TRUE); free((yyvsp[0].sval));}
#line 3342 "rcfile_y.c"
    break;

  case 90: /* smtp_list: smtp_list STRING  */
#line 290 "rcfile_y.y"
                                        {save_str(&current.smtphunt, (yyvsp[0].sval),TRUE); free((yyvsp[0].sval));}
#line 3348 "rcfile_y.c"
    break;

  case 91: /* fetch_list: STRING  */
#line 293 "rcfile_y.y"
                                        {save_str(&current.domainlist, (yyvsp[0].sval),TRUE); free((yyvsp[0].sval));}
#line 3354 "rcfile_y.c"
    break;

  case 92: /* fetch_list: fetch_list STRING  */
#line 294 "rcfile_y.y"
                                        {save_str(&current.domainlist, (yyvsp[0].sval),TRUE); free((yyvsp[0].sval));}
#line 3360 "rcfile_y.c"
    break;

  case 93: /* num_list: NUMBER  */
#line 298 "rcfile_y.y"
                        {
			    struct idlist *id;
			    id = save_str(&current.antispam,STRING_DUMMY,0);
			    id->val.status.num = (yyvsp[0].number);
			}
#line 3370 "rcfile_y.c"
    break;

  case 94: /* num_list: num_list NUMBER  */
#line 304 "rcfile_y.y"
                        {
			    struct idlist *id;
			    id = save_str(&current.antispam,STRING_DUMMY,0);
			    id->val.status.num = (yyvsp[0].number);
			}
#line 3380 "rcfile_y.c"
    break;

  case 99: /* user_option: IS STRING THERE  */
#line 316 "rcfile_y.y"
                                        {current.remotename  = (yyvsp[-1].sval);}
#line 3386 "rcfile_y.c"
    break;

  case 100: /* user_option: PASSWORD STRING  */
#line 317 "rcfile_y.y"
                                        {current.password    = (yyvsp[0].sval);}
#line 3392 "rcfile_y.c"
    break;

  case 101: /* user_option: PASSWORDFILE STRING  */
#line 318 "rcfile_y.y"
                                        {current.passwordfile = (yyvsp[0].sval);}
#line 3398 "rcfile_y.c"
    break;

  case 102: /* user_option: PASSWORDFD NUMBER  */
#line 319 "rcfile_y.y"
                                        {current.passwordfd  = NUM_VALUE_IN((yyvsp[0].number));}
#line 3404 "rcfile_y.c"
    break;

  case 106: /* user_option: SMTPADDRESS STRING  */
#line 323 "rcfile_y.y"
                                        {current.smtpaddress = (yyvsp[0].sval);}
#line 3410 "rcfile_y.c"
    break;

  case 107: /* user_option: SMTPNAME STRING  */
#line 324 "rcfile_y.y"
                                        {current.smtpname =    (yyvsp[0].sval);}
#line 3416 "rcfile_y.c"
    break;

  case 109: /* user_option: MDA STRING  */
#line 326 "rcfile_y.y"
                                        {current.mda         = (yyvsp[0].sval);}
#line 3422 "rcfile_y.c"
    break;

  case 110: /* user_option: BSMTP STRING  */
#line 327 "rcfile_y.y"
                                        {current.bsmtp       = prependdir ((yyvsp[0].sval), rcfiledir); free((yyvsp[0].sval));}
#line 3428 "rcfile_y.c"
    break;

  case 111: /* user_option: LMTP  */
#line 328 "rcfile_y.y"
                                        {current.listener    = LMTP_MODE;}
#line 3434 "rcfile_y.c"
    break;

  case 112: /* user_option: PRECONNECT STRING  */
#line 329 "rcfile_y.y"
                                        {current.preconnect  = (yyvsp[0].sval);}
#line 3440 "rcfile_y.c"
    break;

  case 113: /* user_option: POSTCONNECT STRING  */
#line 330 "rcfile_y.y"
                                        {current.postconnect = (yyvsp[0].sval);}
#line 3446 "rcfile_y.c"
    break;

  case 114: /* user_option: KEEP  */
#line 332 "rcfile_y.y"
                                        {current.keep        = FLAG_TRUE;}
#line 3452 "rcfile_y.c"
    break;

  case 115: /* user_option: MOVETO STRING  */
#line 333 "rcfile_y.y"
                                        {current.moveto      = (yyvsp[0].sval);}
#line 3458 "rcfile_y.c"
    break;

  case 116: /* user_option: FLUSH  */
#line 334 "rcfile_y.y"
                                        {current.flush       = FLAG_TRUE;}
#line 3464 "rcfile_y.c"
    break;

  case 117: /* user_option: LIMITFLUSH  */
#line 335 "rcfile_y.y"
                                        {current.limitflush  = FLAG_TRUE;}
#line 3470 "rcfile_y.c"
    break;

  case 118: /* user_option: FETCHALL  */
#line 336 "rcfile_y.y"
                                        {current.fetchall    = FLAG_TRUE;}
#line 3476 "rcfile_y.c"
    break;

  case 119: /* user_option: REWRITE  */
#line 337 "rcfile_y.y"
                                        {current.rewrite     = FLAG_TRUE;}
#line 3482 "rcfile_y.c"
    break;

  case 120: /* user_option: FORCECR  */
#line 338 "rcfile_y.y"
                                        {current.forcecr     = FLAG_TRUE;}
#line 3488 "rcfile_y.c"
    break;

  case 121: /* user_option: STRIPCR  */
#line 339 "rcfile_y.y"
                                        {current.stripcr     = FLAG_TRUE;}
#line 3494 "rcfile_y.c"
    break;

  case 122: /* user_option: PASS8BITS  */
#line 340 "rcfile_y.y"
                                        {current.pass8bits   = FLAG_TRUE;}
#line 3500 "rcfile_y.c"
    break;

  case 123: /* user_option: DROPSTATUS  */
#line 341 "rcfile_y.y"
                                        {current.dropstatus  = FLAG_TRUE;}
#line 3506 "rcfile_y.c"
    break;

  case 124: /* user_option: DROPDELIVERED  */
#line 342 "rcfile_y.y"
                                        {current.dropdelivered = FLAG_TRUE;}
#line 3512 "rcfile_y.c"
    break;

  case 125: /* user_option: MIMEDECODE  */
#line 343 "rcfile_y.y"
                                        {current.mimedecode  = FLAG_TRUE;}
#line 3518 "rcfile_y.c"
    break;

  case 126: /* user_option: IDLE  */
#line 344 "rcfile_y.y"
                                        {current.idle        = FLAG_TRUE;}
#line 3524 "rcfile_y.c"
    break;

  case 127: /* user_option: FORCEIDLE  */
#line 345 "rcfile_y.y"
                                        {current.forceidle   = FLAG_TRUE;}
#line 3530 "rcfile_y.c"
    break;

  case 128: /* user_option: SSL  */
#line 347 "rcfile_y.y"
                                        {
#ifdef SSL_ENABLE
		    current.use_ssl = FLAG_TRUE;
#else
		    yyerror(GT_("SSL is not enabled"));
#endif 
		}
#line 3542 "rcfile_y.c"
    break;

  case 129: /* user_option: SSLKEY STRING  */
#line 354 "rcfile_y.y"
                                        {current.sslkey = prependdir ((yyvsp[0].sval), rcfiledir); free((yyvsp[0].sval));}
#line 3548 "rcfile_y.c"
    break;

  case 130: /* user_option: SSLCERT STRING  */
#line 355 "rcfile_y.y"
                                        {current.sslcert = prependdir ((yyvsp[0].sval), rcfiledir); free((yyvsp[0].sval));}
#line 3554 "rcfile_y.c"
    break;

  case 131: /* user_option: SSLPROTO STRING  */
#line 356 "rcfile_y.y"
                                        {current.sslproto = (yyvsp[0].sval);}
#line 3560 "rcfile_y.c"
    break;

  case 132: /* user_option: SSLCERTCK  */
#line 357 "rcfile_y.y"
                                        {current.sslcertck = FLAG_TRUE;}
#line 3566 "rcfile_y.c"
    break;

  case 133: /* user_option: SSLCERTFILE STRING  */
#line 358 "rcfile_y.y"
                                        {current.sslcertfile = prependdir((yyvsp[0].sval), rcfiledir); free((yyvsp[0].sval));}
#line 3572 "rcfile_y.c"
    break;

  case 134: /* user_option: SSLCERTPATH STRING  */
#line 359 "rcfile_y.y"
                                        {current.sslcertpath = prependdir((yyvsp[0].sval), rcfiledir); free((yyvsp[0].sval));}
#line 3578 "rcfile_y.c"
    break;

  case 135: /* user_option: SSLCOMMONNAME STRING  */
#line 360 "rcfile_y.y"
                                        {current.sslcommonname = (yyvsp[0].sval);}
#line 3584 "rcfile_y.c"
    break;

  case 136: /* user_option: SSLFINGERPRINT STRING  */
#line 361 "rcfile_y.y"
                                        {current.sslfingerprint = (yyvsp[0].sval);}
#line 3590 "rcfile_y.c"
    break;

  case 137: /* user_option: NO KEEP  */
#line 363 "rcfile_y.y"
                                        {current.keep        = FLAG_FALSE;}
#line 3596 "rcfile_y.c"
    break;

  case 138: /* user_option: NO FLUSH  */
#line 364 "rcfile_y.y"
                                        {current.flush       = FLAG_FALSE;}
#line 3602 "rcfile_y.c"
    break;

  case 139: /* user_option: NO LIMITFLUSH  */
#line 365 "rcfile_y.y"
                                        {current.limitflush  = FLAG_FALSE;}
#line 3608 "rcfile_y.c"
    break;

  case 140: /* user_option: NO FETCHALL  */
#line 366 "rcfile_y.y"
                                        {current.fetchall    = FLAG_FALSE;}
#line 3614 "rcfile_y.c"
    break;

  case 141: /* user_option: NO REWRITE  */
#line 367 "rcfile_y.y"
                                        {current.rewrite     = FLAG_FALSE;}
#line 3620 "rcfile_y.c"
    break;

  case 142: /* user_option: NO FORCECR  */
#line 368 "rcfile_y.y"
                                        {current.forcecr     = FLAG_FALSE;}
#line 3626 "rcfile_y.c"
    break;

  case 143: /* user_option: NO STRIPCR  */
#line 369 "rcfile_y.y"
                                        {current.stripcr     = FLAG_FALSE;}
#line 3632 "rcfile_y.c"
    break;

  case 144: /* user_option: NO PASS8BITS  */
#line 370 "rcfile_y.y"
                                        {current.pass8bits   = FLAG_FALSE;}
#line 3638 "rcfile_y.c"
    break;

  case 145: /* user_option: NO DROPSTATUS  */
#line 371 "rcfile_y.y"
                                        {current.dropstatus  = FLAG_FALSE;}
#line 3644 "rcfile_y.c"
    break;

  case 146: /* user_option: NO DROPDELIVERED  */
#line 372 "rcfile_y.y"
                                        {current.dropdelivered = FLAG_FALSE;}
#line 3650 "rcfile_y.c"
    break;

  case 147: /* user_option: NO MIMEDECODE  */
#line 373 "rcfile_y.y"
                                        {current.mimedecode  = FLAG_FALSE;}
#line 3656 "rcfile_y.c"
    break;

  case 148: /* user_option: NO IDLE  */
#line 374 "rcfile_y.y"
                                        {current.idle        = FLAG_FALSE;}
#line 3662 "rcfile_y.c"
    break;

  case 149: /* user_option: NO FORCEIDLE  */
#line 375 "rcfile_y.y"
                                        {current.forceidle   = FLAG_FALSE;}
#line 3668 "rcfile_y.c"
    break;

  case 150: /* user_option: NO SSL  */
#line 377 "rcfile_y.y"
                                        {current.use_ssl     = FLAG_FALSE;}
#line 3674 "rcfile_y.c"
    break;

  case 151: /* user_option: NO SSLCERTCK  */
#line 378 "rcfile_y.y"
                                        {current.sslcertck   = FLAG_FALSE;}
#line 3680 "rcfile_y.c"
    break;

  case 152: /* user_option: LIMIT NUMBER  */
#line 380 "rcfile_y.y"
                                        {current.limit       = NUM_VALUE_IN((yyvsp[0].number));}
#line 3686 "rcfile_y.c"
    break;

  case 153: /* user_option: WARNINGS NUMBER  */
#line 381 "rcfile_y.y"
                                        {current.warnings    = NUM_VALUE_IN((yyvsp[0].number));}
#line 3692 "rcfile_y.c"
    break;

  case 154: /* user_option: FETCHLIMIT NUMBER  */
#line 382 "rcfile_y.y"
                                        {current.fetchlimit  = NUM_VALUE_IN((yyvsp[0].number));}
#line 3698 "rcfile_y.c"
    break;

  case 155: /* user_option: FETCHSIZELIMIT NUMBER  */
#line 383 "rcfile_y.y"
                                        {current.fetchsizelimit = NUM_VALUE_IN((yyvsp[0].number));}
#line 3704 "rcfile_y.c"
    break;

  case 156: /* user_option: FASTUIDL NUMBER  */
#line 384 "rcfile_y.y"
                                        {current.fastuidl    = NUM_VALUE_IN((yyvsp[0].number));}
#line 3710 "rcfile_y.c"
    break;

  case 157: /* user_option: BATCHLIMIT NUMBER  */
#line 385 "rcfile_y.y"
                                        {current.batchlimit  = NUM_VALUE_IN((yyvsp[0].number));}
#line 3716 "rcfile_y.c"
    break;

  case 158: /* user_option: EXPUNGE NUMBER  */
#line 386 "rcfile_y.y"
                                        {current.expunge     = NUM_VALUE_IN((yyvsp[0].number));}
#line 3722 "rcfile_y.c"
    break;

  case 159: /* user_option: PROPERTIES STRING  */
#line 388 "rcfile_y.y"
                                        {current.properties  = (yyvsp[0].sval);}
#line 3728 "rcfile_y.c"
    break;


#line 3732 "rcfile_y.c"

        default: break;
      }
    if (yychar_backup != yychar)
      YY_LAC_DISCARD ("yychar change");
  }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      {
        yypcontext_t yyctx
          = {yyssp, yyesa, &yyes, &yyes_capacity, yytoken};
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        if (yychar != YYEMPTY)
          YY_LAC_ESTABLISH;
        yysyntax_error_status = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == -1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = YY_CAST (char *,
                             YYSTACK_ALLOC (YY_CAST (YYSIZE_T, yymsg_alloc)));
            if (yymsg)
              {
                yysyntax_error_status
                  = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
                yymsgp = yymsg;
              }
            else
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = YYENOMEM;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == YYENOMEM)
          YYNOMEM;
      }
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  /* If the stack popping above didn't lose the initial context for the
     current lookahead token, the shift below will for sure.  */
  YY_LAC_DISCARD ("error recovery");

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  if (yyes != yyesa)
    YYSTACK_FREE (yyes);
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
  return yyresult;
}

#line 390 "rcfile_y.y"


static struct query *hosttail;	/* where to add new elements */

/** check that a configuration file is secure, returns PS_* status codes */
int prc_filecheck(const char *pathname,
		  const flag securecheck /** shortcuts permission, filetype and uid tests if false */)
{
    struct stat statbuf;

    errno = 0;

    /* special case useful for debugging purposes */
    if (strcmp("/dev/null", pathname) == 0)
	return(PS_SUCCESS);

    /* pass through the special name for stdin */
    if (strcmp("-", pathname) == 0)
	return(PS_SUCCESS);

    /* the run control file must have the same uid as the REAL uid of this 
       process, it must have permissions no greater than 600, and it must not 
       be a symbolic link.  We check these conditions here. */

    if (stat(pathname, &statbuf) < 0) {
	if (errno == ENOENT) 
	    return(PS_SUCCESS);
	else {
	    report(stderr, "lstat: %s: %s\n", pathname, strerror(errno));
	    return(PS_IOERR);
	}
    }

    if (!securecheck)	return PS_SUCCESS;

    if (!S_ISREG(statbuf.st_mode))
    {
	fprintf(stderr, GT_("File %s must be a regular file.\n"), pathname);
	return(PS_IOERR);
    }

    if (statbuf.st_mode & (S_IRGRP | S_IWGRP | S_IROTH | S_IWOTH | S_IXOTH))
    {
	fprintf(stderr, GT_("File %s must have no more than -rwx------ (0700) permissions.\n"), 
		pathname);
	return(PS_IOERR);
    }

    if (statbuf.st_uid != geteuid())
    {
	fprintf(stderr, GT_("File %s must be owned by you.\n"), pathname);
	return(PS_IOERR);
    }
    return(PS_SUCCESS);
}

int prc_parse_file (const char *pathname, const flag securecheck)
/* digest the configuration into a linked list of host records */
{
    prc_errflag = 0;
    querylist = hosttail = (struct query *)NULL;

    errno = 0;

    /* Check that the file is secure */
    if ( (prc_errflag = prc_filecheck(pathname, securecheck)) != 0 )
	return(prc_errflag);

    /*
     * Croak if the configuration directory does not exist.
     * This probably means an NFS mount failed and we can't
     * see a configuration file that ought to be there.
     * Question: is this a portable check? It's not clear
     * that all implementations of lstat() will return ENOTDIR
     * rather than plain ENOENT in this case...
     */
    if (errno == ENOTDIR)
	return(PS_IOERR);
    else if (errno == ENOENT)
	return(PS_SUCCESS);

    /* Open the configuration file and feed it to the lexer. */
    if (strcmp(pathname, "-") == 0)
	yyin = stdin;
    else if ((yyin = fopen(pathname,"r")) == (FILE *)NULL) {
	report(stderr, "open: %s: %s\n", pathname, strerror(errno));
	return(PS_IOERR);
    }

    int parseerr = yyparse();		/* parse entire file */

    if (2 == parseerr) {
	report(stderr, GT_("%s: parsing rcfile %s: memory exhausted\n"), program_name, pathname);
	return PS_IOERR;
    }

    if (yyin != stdin)
       fclose(yyin);	/* not checking this should be safe, file mode was r */

    if (prc_errflag || parseerr)
	return PS_SYNTAX;

    return PS_SUCCESS;
}

static void reset_server(const char *name, int skip)
/* clear the entire global record and initialize it with a new name */
{
    trailer = FALSE;
    memset(&current,'\0',sizeof(current));
    current.smtp_socket = -1;
    current.passwordfd = -1;
    current.server.pollname = xstrdup(name);
    current.server.skip = skip;
}


static void user_reset(void)
/* clear the global current record (user parameters) used by the parser */
{
    struct hostdata save;

    /*
     * Purpose of this code is to initialize the new server block, but
     * preserve whatever server name was previously set.  Also
     * preserve server options unless the command-line explicitly
     * overrides them.
     */
    save = current.server;

    memset(&current, '\0', sizeof(current));
    current.smtp_socket = -1;
    current.passwordfd = -1;

    current.server = save;
}

/** append a host record to the host list */
struct query *hostalloc(struct query *init /** pointer to block containing
					       initial values */)
{
    struct query *node;

    /* allocate new node */
    node = (struct query *) xmalloc(sizeof(struct query));

    /* initialize it */
    if (init)
	memcpy(node, init, sizeof(struct query));
    else
    {
	memset(node, '\0', sizeof(struct query));
	node->smtp_socket = -1;
	node->passwordfd = -1;
    }

    /* append to end of list */
    if (hosttail != (struct query *) 0)
	hosttail->next = node;	/* list contains at least one element */
    else
	querylist = node;	/* list is empty */
    hosttail = node;

    if (trailer)
	node->server.lead_server = leadentry;
    else
    {
	node->server.lead_server = NULL;
	leadentry = &node->server;
    }

    return(node);
}

static void record_current(void)
/* register current parameters and append to the host list */
{
    (void) hostalloc(&current);
    trailer = TRUE;
}

char *prependdir (const char *file, const char *dir)
/* if a filename is relative to dir, convert it to an absolute path */
{
    char *newfile;
    if (!file[0] ||			/* null path */
	file[0] == '/' ||		/* absolute path */
	strcmp(file, "-") == 0 ||	/* stdin/stdout */
	!dir[0])			/* we don't HAVE_GETCWD */
	return xstrdup (file);
    newfile = (char *)xmalloc (strlen (dir) + 1 + strlen (file) + 1);
    if (dir[strlen(dir) - 1] != '/')
	sprintf (newfile, "%s/%s", dir, file);
    else
	sprintf (newfile, "%s%s", dir, file);
    return newfile;
}

/* rcfile_y.y ends here */
